class Treatments {
  
  ArrayList<Point> [] treatmentArrays = new ArrayList[numTreatments];
  ArrayList<Point> [] sortedTreatments = new ArrayList[numTreatments];
  
  Treatments () {
    for (int i = 0; i < numTreatments; i++) {
      treatmentArrays[i] = new ArrayList<Point>();
      sortedTreatments[i] = new ArrayList<Point>();
    }
  }
  
  void addToCorrectArray (int treatmentNum, Point newPoint) {
    int treatmentIndex = treatmentNum -1;
    treatmentArrays[treatmentIndex].add(newPoint);
  }
  
  void fillArray (ArrayList<Point> array, color c) {
    int theSize = array.size();
    curveTightness(1);
    beginShape();
    if (showLines == false) {
      noStroke();
    }
    else {
      stroke(c);
    }
    fill(c, 40);
    float baseZ = array.get(0).getZ();
    float baseX = array.get(0).getX();
     // X Conc, Y OD, Z TRX
    
    vertex(baseX, maxY, baseZ);
    
    for (int i=0; i < theSize; i++) {
      Point currentPoint = array.get(i);
      float x = currentPoint.getX();
      float y = currentPoint.getY();
      float z = currentPoint.getZ();
      vertex(x, y, z);
      if (i == 1 || i == theSize -1) {
        vertex(x, y, z);
      }
    }
    float endZ = array.get(theSize-1).getZ();
    float endX = array.get(theSize-1).getX();
    vertex(endX,maxY,endZ);
    vertex(baseX, maxY, baseZ);
    endShape();
    
  }
  
  void drawPoints () {
    for (int i = 0; i < numTreatments; i++) {
      if (treatmentBoolValues[i]) {
        ArrayList<Point> currentArray = treatmentArrays[i];
        int arraySize = currentArray.size();
        for (int j = 0; j < arraySize; j++) {
          Point currentPoint = currentArray.get(j);
          if (showEffective) {
            effectiveColor(currentArray);
          }
          
          stroke(currentPoint.getColor());
          strokeWeight(currentPoint.getTheStroke());
          point(currentPoint.getX(), currentPoint.getY(), currentPoint.getZ());
        }
      }
    }
  }
  
  void drawArray (ArrayList<Point> array, color c) {
    int theSize = array.size();
    curveTightness(1);
    beginShape();
    noFill();
    stroke(c);
    for (int i=0; i < theSize; i++) {
      Point currentPoint = array.get(i);
      float x = currentPoint.getX();
      float y = currentPoint.getY();
      float z = currentPoint.getZ();
      vertex(x, y, z);
      if (i == 0 || i == theSize -1) {
        vertex(x, y, z);
      }
    }
    endShape();
  }
  
  void drawLine(boolean fill) {
    for (int i = 0; i < numTreatments; i++) {
      if (treatmentBoolValues[i]) {
        sort (treatmentArrays[i], new AscendingOrder());
        if (differStrain) {
          theMaxPoints(treatmentArrays[i], fill, colors[i]);
        }
        else if (highlightAntibiotics) { 
          int colorIndex = antibioticIndices[i];
          theMaxPoints(treatmentArrays[i], fill, antPhageColors[colorIndex]);
        }
        else if (highlightPhages) {
          int colorIndex = phageIndices[i];
          theMaxPoints(treatmentArrays[i], fill, antPhageColors[colorIndex]);
        }
        else {
          theMaxPoints(treatmentArrays[i], fill, 255);
        }
      }
    }
  }
  
  void drawAverageLine () {
    for (int i = 0; i < numTreatments; i++) {
      sort (treatmentArrays[i], new AscendingOrder());     
      ArrayList<Point> theAveragePoints = averageLine (treatmentArrays[i]);
      drawArray (theAveragePoints, colors[i]);
    }
  }
    
  void theMaxPoints (ArrayList<Point> array, boolean fill, color c) {
    ArrayList<Point> maxPoints = new ArrayList<Point>();
    int theSize = array.size();
    
    if (theSize > 0) {
      Point prevPoint = array.get(0);
      Point currentMax = prevPoint;
      for (int i=1; i < theSize; i++) {
        Point currentPoint = array.get(i);
        
        if (prevPoint.getX() == currentPoint.getX()) {
           float maxY = Math.min(prevPoint.getY(), currentPoint.getY());
           currentMax = new Point (currentPoint.getX(), maxY, currentPoint.getZ()); 
           prevPoint = currentPoint;
        }
        else {
          maxPoints.add(currentMax);
          currentMax = currentPoint;
          prevPoint = currentPoint;
        }
      }
      
      Point lastPoint = array.get(theSize -1);
      maxPoints.add(lastPoint);
      if (fill == true) {
        fillArray(maxPoints, c);
      }
      else {
        drawArray(maxPoints, c);
      }
    }
  }
  
}
